/////////////////////////////////////////////////////////////////////////////
// Name:        No names yet.
// Purpose:     Contrib. demo
// Author:      Aleksandras Gluchovas
// Modified by:
// Created:     2000/02/08
// RCS-ID:      
// Copyright:   (c) Aleksandras Gluchovas
// Licence:   	GPL (version 2.0 or later)
/////////////////////////////////////////////////////////////////////////////

#ifndef __PM_FLMGR_G__
#define __PM_FLMGR_G__

#include "wx/pmf/pm_doc.h"
#include "wx/pmf/pm.h"

class wxFrameLayout;

class wxPMFrameLayoutPreferenceTemplate;
class wxPMFrameLayoutPreference;

WX_DEFINE_ARRAY( wxPMFrameLayoutPreferenceTemplate*, PMFrameLayoutPreferenceTemplateListT );

class wxPMFrameLayoutPreferenceTemplate : public wxObject
{
public:
	wxPMFrameLayoutPreferenceTemplate( wxClassInfo* pPaneClass,
									   wxPMFrameLayoutPreference* pPreference );
	~wxPMFrameLayoutPreferenceTemplate();

public:
	wxClassInfo* m_pPaneClass;
	wxPMFrameLayoutPreference* m_pPrefrence;
};


class wxPMFrameLayoutPreference : public wxPMLayoutPreference
{
public:
	wxPMFrameLayoutPreference();
	wxPMFrameLayoutPreference( int alignment, int orderIndex );

	// overriden method of wxPMLayoutPrefernce
	virtual void Serialize( wxConfigBase& cfg, const wxString& key, bool isLoading );

	void SetAlignment( int alignment );
	int  GetAlignment();
	void SetOrderIndex( int index );
	int  GetOrderIndex();
	void SetWidth( int width );
	int  GetWidth();


	DECLARE_DYNAMIC_CLASS( wxPMFrameLayoutPreference )

protected:
	int m_Alignment;
	int m_OrderIndex;
	int m_Width;
};

class wxPMFrameLayoutAlgorithm : public wxPMLayoutAlgorithm, public wxPMBootstrapServiceListener
							 
{
public:
	wxPMFrameLayoutAlgorithm();
	~wxPMFrameLayoutAlgorithm();

	// overriden methods of wxPMService
	virtual bool Start();
	virtual bool Stop();

	// overriden notifications of wxPMBootstrapServiceListener
	virtual void OnPaneShown( wxPMPane& pane );
	virtual void OnPaneHidden( wxPMPane& pane );
	virtual void OnServiceStarted( wxPMService& service );
	virtual void OnServiceStopped( wxPMService& service );

	// overriden method of wxPMLayoutAlgorithm
	virtual wxPMLayoutPreference* CreateDefaultLayoutPrefs();

	// overriden method of wxPMService
	virtual void Serialize( wxConfigBase& cfg, const wxString& key, bool isLoading );

	virtual void AddPrefernceTemplate( wxPMFrameLayoutPreferenceTemplate* pTempl );
	virtual void AddPrefernceTemplate( wxClassInfo* pClass, wxPMFrameLayoutPreference* pPref );

	/*** event-handlers ***/

	DECLARE_DYNAMIC_CLASS( wxPMFrameLayoutAlgorithm )

protected:
	void DoRelayout();

protected:
	PMPaneListT m_TopLevelPanes;
	PMPaneListT m_ActivePanes;
	PMFrameLayoutPreferenceTemplateListT m_PrefTemplates;

	bool m_RelayoutPending;
	int  m_NextWndId;

	wxFrameLayout* m_pLayout;
};


#endif // __PM_FLMGR_G__