/////////////////////////////////////////////////////////////////////////////
// Name:        No names yet.
// Purpose:     Contrib. demo
// Author:      Aleksandras Gluchovas
// Modified by:
// Created:     2000/02/08
// RCS-ID:      
// Copyright:   (c) Aleksandras Gluchovas
// Licence:   	GPL (version 2.0 or later)
/////////////////////////////////////////////////////////////////////////////

#ifdef __GNUG__
    #pragma implementation "pm_doc.cpp"
    #pragma interface "pm_doc.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "wx/pmf/pm_doc.h"

#include "wx/pmf/pm_inf_text.h"

#include "wx/pmf/pm.h" // imports wxPMBootStrapService

/***** Implementation for class wxPMLayoutPrefs *****/

void wxPMWorkplaceListener::OnWorkplaceOpened( wxPMWorkplace& workplace )
{}

void wxPMWorkplaceListener::OnWorkplaceClosing( wxPMWorkplace& workplace )
{}

void wxPMWorkplaceListener::OnProjectAdded( wxPMProject& project )
{}

void wxPMWorkplaceListener::OnProjectRemoved( wxPMProject& project )
{}

void wxPMWorkplaceListener::OnProjectActivated( wxPMProject& project, wxPMProject* pPrevProject )
{}

void wxPMWorkplaceListener::OnFileAdded( wxPMFileInfo& file, wxPMProject* pToProject )
{}

void wxPMWorkplaceListener::OnFileRemoved( wxPMFileInfo& file, wxPMProject* pToProject )
{}

void wxPMWorkplaceListener::OnViewActiavated( wxPMView& view, wxPMView* pPrevView )
{}


/***** Implementation for class wxPMLayoutPreference *****/

IMPLEMENT_DYNAMIC_CLASS( wxPMLayoutPreference, wxObject )

wxPMLayoutPreference::wxPMLayoutPreference()
{}

void wxPMLayoutPreference::Serialize( wxConfigBase& cfg, const wxString& key, bool isLoading )

{ /* nothing by default */ }

/***** Implementation for class wxPMView *****/

IMPLEMENT_DYNAMIC_CLASS( wxPMView, wxView )

wxPMView::wxPMView()

	: m_pViewFrame( NULL ),
	  m_IsClosing( FALSE )
{
	SetRefData( (wxObjectRefData*)(wxPMService*)this );
}

wxPMView::~wxPMView()
{
	SetRefData( NULL );
}

wxPMMergableMenuChain* wxPMView::GetMergableMenuChain()
{
	return NULL; // no menus by default
}

wxObject* wxPMView::GetWxObject()
{
	return (wxObject*)this;
}

void wxPMView::OnDraw( wxDC* pDc )

{ 
	pDc->DrawLine( 5,5, 500,500 );

	/* almost nothing by default*/ 
}

/** helper class **/

class MyDocMDIChildFrame : public wxDocMDIChildFrame
{
public:
	MyDocMDIChildFrame( wxDocument* doc, wxView* view, 
						wxMDIParentFrame* parent, wxWindowID id, 
						const wxString& title, 
						const wxPoint& pos = wxDefaultPosition, 
						const wxSize& size = wxDefaultSize, 
						long style = wxDEFAULT_FRAME_STYLE | wxTAB_TRAVERSAL, 
						const wxString& name = "frame")
		: wxDocMDIChildFrame( doc,view,parent,id,title,pos,size,style,name )
	{}

	void OnChar( wxKeyEvent& event )
	{
		if ( event.KeyCode() != WXK_CONTROL )

			wxPMBootSvc().TranslateKeyEvent( event );
	}

	void OnLeftDown( wxMouseEvent& event )
	{
		if ( wxWindow::FindFocus() != this )

			this->SetFocus();

		event.Skip();
	}

	void OnCommandRange( wxCommandEvent& event )
	{
		if ( event.m_eventType = wxEVT_COMMAND_BUTTON_CLICKED )

			event.m_eventType = wxEVT_COMMAND_MENU_SELECTED;

		if ( GetView()->ProcessEvent( event ) )
		
			event.Skip( FALSE );
		else
			event.Skip( TRUE );
	}

	void OnSetFocus( wxFocusEvent& event )
	{
		wxNode* pNode = GetChildren().First();

			if ( pNode )
			{
				//m_childView->Activate(true);

				((wxWindow*)pNode->GetData())->SetFocus();

				return;
			}

		event.Skip();
	}

	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE( MyDocMDIChildFrame, wxDocMDIChildFrame )

	EVT_SET_FOCUS( MyDocMDIChildFrame::OnSetFocus )
	EVT_COMMAND_RANGE( 0, 65530, wxEVT_COMMAND_BUTTON_CLICKED, 
					   MyDocMDIChildFrame::OnCommandRange )
	EVT_COMMAND_RANGE( 0, 65530, wxEVT_COMMAND_MENU_SELECTED , 
					   MyDocMDIChildFrame::OnCommandRange )
	EVT_COMMAND_RANGE( 0, 65530, wxEVT_COMMAND_TEXT_UPDATED, 
					   MyDocMDIChildFrame::OnCommandRange )

	EVT_KEY_DOWN( MyDocMDIChildFrame::OnChar )
	//EVT_CHAR( MyDocMDIChildFrame::OnChar )

	EVT_LEFT_DOWN( MyDocMDIChildFrame::OnLeftDown )

END_EVENT_TABLE()

// FIXME:: should be made static member of wxPMView
static wxPoint _gLRU_DocPos( 5,5 );

bool wxPMView::OnCreate(wxDocument* doc, long flags)
{
  //// Make a child frame
	m_pViewFrame = 
		new MyDocMDIChildFrame(doc, this, 
							   wxPMBootSvc().GetMainWindow(), -1, 
							   "Child Frame",
							   _gLRU_DocPos, wxSize(500, 400), 
							   wxDEFAULT_FRAME_STYLE | wxTAB_TRAVERSAL );

	m_pViewFrame->SetFocus();

	_gLRU_DocPos.x += 20;
	_gLRU_DocPos.y += 20;

	if ( _gLRU_DocPos.x > 200 )
	{
		_gLRU_DocPos.x = 5;
		_gLRU_DocPos.y = 5;
	}

	return TRUE;
}

class MyDummyView : public wxPMView
{
public: virtual void Activate( bool activate ) {};
};

bool wxPMView::OnClose(bool deleteWindow)
{
	if ( !IsClosing() )
	{
		SetClosing( TRUE ); // set "reentrance flags" upon very first
							// attempt to close this view

		wxPMDocument* pDoc = (wxPMDocument*)GetDocument();
		wxPMDocManager* pDocMan = (wxPMDocManager*)pDoc->GetDocumentManager();

		wxList* pLst = pDoc->GetAllViews();

		wxNode* pFirst = pLst->GetFirst();
		wxNode* pLast = pLst->GetLast();
		size_t cnt = pLst->GetCount();

		if ( pFirst != NULL && pFirst == pLast ) // the last view closes the document
		{
			if ( pDocMan->CloseDocument( pDoc ) )
			{
				return TRUE;
			}
			else
			{
				SetClosing( FALSE ); // closing canceled, reset
									 // the "reentrance-flags" accordingly
				return FALSE;
			}
		}
		else
			return TRUE;
	}
	else
		// otherwise the closing already was in progress,
		// do not show any reasistance...

		return TRUE;
}

void wxPMView::OnActivateView(bool activate, wxView *activeView, wxView *deactiveView)
{
	wxPMBootSvc().SetStatusText( "" );
 
	if ( activate ) 
	{
		if ( deactiveView && deactiveView != this )
		{
			wxASSERT( activeView->IsKindOf( CLASSINFO(wxPMView) ) );

			wxPMView* pPMView = (wxPMView*)deactiveView;

			if ( pPMView->IsStarted() )

				wxPMBootSvc().StopService( pPMView );
		}

		if ( !IsStarted() )

			wxPMBootSvc().StartService( this );

		((wxPMDocument*)GetDocument())->OnActivatePMDocument();
		wxPMBootSvc().ActiaveteRelatedPanes( (wxPMDocument*)GetDocument(), TRUE );
	}
}

void wxPMView::Activate( bool activate )
{
	wxView::Activate( activate );
}

void wxPMView::SetClosing( bool closing )
{
	m_IsClosing = closing;
}

bool wxPMView::IsClosing()
{
	return m_IsClosing;
}

wxWindow* wxPMView::GetViewFrame()
{
	return m_pViewFrame;
}

wxWindow* wxPMView::GetViewClient()
{
	return NULL; // not client-window by default
}

/***** Implementation for class wxPMLayoutAlgorithm *****/

IMPLEMENT_DYNAMIC_CLASS( wxPMLayoutAlgorithm, wxEvtHandler )

wxPMLayoutAlgorithm::wxPMLayoutAlgorithm()
{
	SetRefData( (wxObjectRefData*)(wxPMService*)this );
}

wxPMLayoutAlgorithm::~wxPMLayoutAlgorithm()
{
	SetRefData( NULL );
}

bool wxPMLayoutAlgorithm::Start()
{
	return TRUE;
}

bool wxPMLayoutAlgorithm::Stop()
{
	return TRUE;
}

wxObject* wxPMLayoutAlgorithm::GetWxObject()
{
	return (wxObject*)this;
}

wxPMLayoutPreference* wxPMLayoutAlgorithm::CreateDefaultLayoutPrefs()
{
	wxFAIL_MSG( "wxPMLayoutAlgorithm::CreateDefaultLayoutPrefs() should be overriden in the derived classes!" );

	return NULL;
}

bool wxPMLayoutAlgorithm::SerializeState( wxPMSerializer& ser )

{ return TRUE; /* nothing by default */ }

/***** Implementation for class wxPMPane *****/

IMPLEMENT_DYNAMIC_CLASS( wxPMPane, wxEvtHandler )

wxPMPane::wxPMPane()

	: m_pDoc( NULL ),
	  m_pLayoutPref( NULL ),
	  m_pParentPane( NULL ),
	  m_IsShown( FALSE )
{
	// TBD:: comments
	SetRefData( (wxObjectRefData*)(wxPMService*)this );
}

wxPMPane::~wxPMPane()
{
	SetRefData( NULL );

	if ( m_pLayoutPref ) delete m_pLayoutPref;
}

void wxPMPane::SetParentPane( wxPMPane* pPane )
{
	m_pParentPane = pPane;
}

void wxPMPane::AddChildPane( wxPMPane* pPane )
{
	m_ChildPanes.Add( pPane );
	pPane->SetParentPane( this );
}

wxPMPane* wxPMPane::GetParentPane()
{
	return m_pParentPane;
}

PMPaneListT& wxPMPane::GetChildPanes()
{
	return m_ChildPanes;
}

void wxPMPane::ActivateChildPane( wxPMPane* pPane )
{
	/* nothing by default */
}

bool wxPMPane::Start()
{
	return TRUE;
}

wxObject* wxPMPane::GetWxObject()
{
	return (wxObject*)this;
}

wxWindow* wxPMPane::GetPaneWindow()
{
	wxFAIL_MSG( "wxPMPane::GetPaneWindow() should be overriden by the derived classes!" );

	return NULL;
}

void wxPMPane::CreatePaneWindow( wxWindow* pParent )
{
	wxFAIL_MSG( "wxPMPane::CreatePaneWindow() should be overriden by the derived classes!" );
}

wxStringList* wxPMPane::GetDocumentTypes()
{
	return NULL;
}

wxStringList* wxPMPane::GetDocumentStates( const wxString& forDocType )
{
	return NULL;
}

void wxPMPane::SetDocument( wxPMDocument* pDoc )
{
	m_pDoc = pDoc;
}

wxPMDocument* wxPMPane::GetDocument()
{
	return m_pDoc;
}

void wxPMPane::OnDocumentActivated( wxPMDocument* pDoc )
{
}

void wxPMPane::OnDocumentDeactivated( wxPMDocument* pDoc )
{
}

void wxPMPane::OnClosingWorkplace()
{
}

wxPMLayoutPreference* wxPMPane::GetLayoutPefs()
{
	return m_pLayoutPref;
}

void wxPMPane::SetLayoutPrefs( wxPMLayoutPreference* pPrefs )
{
	m_pLayoutPref = pPrefs;
}

void wxPMPane::SetShown( bool shown )
{
	m_IsShown = shown;
}

bool wxPMPane::IsShown()
{
	return m_IsShown;
}

bool wxPMPane::SerializeState( wxPMSerializer& ser )
{
	return TRUE; // TBD:: serialize layout-preferences
}

/***** Implementation for class wxPMDocument *****/

IMPLEMENT_DYNAMIC_CLASS( wxPMDocument, wxDocument )

wxPMDocument::wxPMDocument()

	: m_pParentDoc( NULL ),
	  m_pFile( NULL )
{
	SetRefData( (wxObjectRefData*)(wxPMService*)this );
}

wxPMDocument::~wxPMDocument()
{
	SetRefData( NULL );

	//WX_CLEAR_ARRAY( m_Subdocuments );
	// this should not be done here, intead wxPMDocManager
	// takes care of deleting docuemnt-objects, because deletion
	// of them in PM have similar complications as with objects of wxWindow

	if ( m_pFile ) delete m_pFile;
}

wxPMMergableMenuChain* wxPMDocument::GetMergableMenuChain()
{
	return NULL; // none by default
}

wxObject* wxPMDocument::GetWxObject()
{
	return (wxObject*)this;
}

bool wxPMDocument::CanHaveFile()
{
	return TRUE;
}

void wxPMDocument::SetParentDocument( wxPMDocument* pParent )
{
	m_pParentDoc = pParent;
}

wxPMDocument* wxPMDocument::GetParentDocument()
{
	return m_pParentDoc;
}

void wxPMDocument::AddSubdocument( wxPMDocument* pSubdoc )
{
	pSubdoc->SetParentDocument( this );

	m_Subdocuments.Add( pSubdoc );
}

void wxPMDocument::RemoveSubdocument( wxPMDocument* pSubdoc )
{
	pSubdoc->SetParentDocument( NULL );

	m_Subdocuments.Remove( pSubdoc );
}

wxPMDocument* wxPMDocument::FindSubdocumentForFile( const wxPMFileInfo& finfo )
{
	// search documents recursively

	for( size_t i = 0; i != m_Subdocuments.Count(); ++i )
	{
		wxPMDocument* doc = m_Subdocuments[i];

		if ( doc->CanHaveFile() && doc->GetFileInfo() &&
			 *doc->GetFileInfo() == finfo 
		   )

		   return doc;

		wxPMDocument* pFound = m_Subdocuments[i]->FindSubdocumentForFile( finfo );

		if ( pFound ) return pFound;
	}

	return NULL;
}

void wxPMDocument::AssociateService( wxClassInfo* pSvcClass )
{
	m_ServiceClasses.Add( pSvcClass );
}

PMClassInfoListT& wxPMDocument::GetAssociatedServices()
{
	return m_ServiceClasses;
}

void wxPMDocument::OnClosingChildDocument( wxPMDocument* pChild, bool wasSaved )
{
	// nothing by default
}

void wxPMDocument::SetFileInfo( wxPMFileInfo* pFile )
{ 
	m_pFile = pFile;
}

wxPMFileInfo* wxPMDocument::GetFileInfo()

{ 
	wxASSERT_MSG( CanHaveFile() == TRUE, "Please, check CanHaveFile() before calling GetFile()!" );

	return m_pFile;
}

bool wxPMDocument::UseSerializer()
{
	return FALSE;
}

bool wxPMDocument::SavePMDocument( wxOutputStream& s )
{
	return TRUE;
}

bool wxPMDocument::LoadPMDocument( wxInputStream& s )
{
	return TRUE;
}

bool wxPMDocument::SerializePMDocument( wxPMSerializer& ser )
{
	return TRUE;
}

bool wxPMDocument::SerializeState( wxPMSerializer& ser )
{
	return TRUE;
}

bool wxPMDocument::SavePMDocument()
{
	return TRUE;
}

bool wxPMDocument::LoadPMDocument()
{
	return TRUE;
}

PMDocumentListT& wxPMDocument::GetSubdocuments()
{
	return m_Subdocuments;
}

wxList* wxPMDocument::GetAllViews()
{
	return &m_documentViews;
}

void wxPMDocument::OnActivatePMDocument()
{
	// nothing by default
}

/***** Implementation for class wxPMProject *****/

// TBD:: should be made statics of wxPMProject class

static wxCommandInfo _gProjectCommands[] = {

	wxCommandInfo( wxPMProject::ID_ADD_FILE,  "Insert &file..." ), 
	wxCommandInfo( wxPMProject::ID_ADD_FILES, "Insert files by &mask..." ), 
	wxCommandInfo( wxPMProject::ID_ADD_FILES_RECURSIVELY, "Insert files &recursively..." ), 

	wxCommandInfo( -1, "SEPARATOR" ),

	wxCommandInfo( wxPMProject::ID_PROJECT_SETTINGS, "&Settings..." ), 

	wxCommandInfo( 0, "" ) // terminator
};

static wxPMMergableMenuChain _gProjectChains[] = {

	wxPMMergableMenuChain( "/&Project/", _gProjectCommands ),

	wxPMMergableMenuChain( "", NULL ) // terminator
};

IMPLEMENT_DYNAMIC_CLASS( wxPMProject, wxPMDocument )

BEGIN_EVENT_TABLE( wxPMProject, wxDocument )

	EVT_MENU( wxPMProject::ID_ADD_FILE,              wxPMProject::OnCmdAddFile )
	EVT_MENU( wxPMProject::ID_ADD_FILES,             wxPMProject::OnCmdAddFiles )
	EVT_MENU( wxPMProject::ID_ADD_FILES_RECURSIVELY, wxPMProject::OnCmdFilesRecursively )
	EVT_MENU( wxPMProject::ID_PROJECT_SETTINGS,      wxPMProject::OnCmdProjectSettings )

END_EVENT_TABLE()

wxPMProject::wxPMProject()
	
	: wxPMDocument()
{}

wxPMProject::~wxPMProject()
{
	// subdocuments are not destroyed here!
}

wxPMMergableMenuChain* wxPMProject::GetMergableMenuChain()
{
	if ( GetParentDocument() &&
		 ((wxPMWorkplace*)GetParentDocument())->IsActiveProject( this ) )

		 // insert project-menus only when this project is currently active!
		return _gProjectChains;
	else
		return NULL;
}

bool wxPMProject::AddMultipleFiles( PMFileInfoListT& lst )
{
	wxString errors = "";
	for( size_t i = 0; i != lst.Count(); ++i )
	{
		wxPMFileInfo* pInfo = lst[i];

		if ( !pInfo->DetectType() )
		{
			errors += "\n" + pInfo->GetPath();

			delete pInfo;
			continue;
		}

		if ( ContainsFile( *pInfo ) )
		{
			errors += "\n" + pInfo->GetPath() + "[already included]";

			delete pInfo;
			continue;
		}

		m_Files.Add( lst[i] );		

		wxPMBootSvc().GetWorkplace()->NotifyFileAdded( *lst[i], this );

		// TBD:: mutiliple errros...
	}

	if ( errors.Length() != 0 )
	{
		wxMessageBox( "Type or location of the following file(s) could not be detected:\n" +
					  errors );

		return FALSE;
	}

	return TRUE;
}

bool wxPMProject::AddFile( wxPMFileInfo* pFile )
{
	PMFileInfoListT lst;
	lst.Add( pFile );

	Modify( TRUE );

	return AddMultipleFiles( lst );
}

bool wxPMProject::RemoveFile( wxPMFileInfo* pFile )
{
	// TBD:: error check

	wxPMBootSvc().GetWorkplace()->NotifyFileRemoved( *pFile, this );

	m_Files.Remove( pFile );

	delete pFile;

	Modify( TRUE );

	return TRUE;
}

PMFileInfoListT& wxPMProject::GetFiles()
{
	return m_Files;
}

void wxPMProject::FindFilesByMimeType( const wxString& mimeType, PMFileInfoListT& toLst )
{
	for( size_t i = 0; i != m_Files.Count(); ++i )
	{
		if ( m_Files[i]->GetType() == mimeType )
		
			toLst.Add( m_Files[i] );
	}
}

wxPMFileInfo* wxPMProject::FindFile( const wxString& shortFileName )
{
	if ( !shortFileName.Length() ) 

		return NULL;

	for( size_t i = 0; i != m_Files.Count(); ++i )
	
		if ( m_Files[i]->GetNameWithoutPath() == shortFileName )

			return m_Files[i];
	
	return NULL;
}

bool wxPMProject::ContainsFile( const wxPMFileInfo& finfo )
{
	for( size_t i = 0; i != m_Files.Count(); ++i )
	{
		wxPMFileInfo& file = *m_Files[i];

		if ( *m_Files[i] == finfo )

			return TRUE;
	}

	return FALSE;
}

wxPMDocument* wxPMProject::FindDocumnetByFile( const wxPMFileInfo& file )
{
	PMDocumentListT& lst = GetSubdocuments();

    unsigned int i;
	for( i = 0; i != lst.Count(); ++i )
	{
		wxPMDocument& doc = *(wxPMDocument*)lst[i];

		wxPMFileInfo* pFile = doc.GetFileInfo();

		if ( *pFile == file )

			return &doc;
	}
	
	return NULL;
}

bool wxPMProject::GetFileTextContent( const wxPMFileInfo& file, wxString& toStr )
{
	wxPMDocument* pDoc = FindDocumnetByFile( file );

	if ( pDoc )
	{
		wxPMInf_ContainingText* pInf = 
			(wxPMInf_ContainingText*)pDoc->GetInterface( "wxPMInf_ContainingText" );

		if ( pInf )

			return pInf->GetAllText( &toStr );
	}

	// otherwise, either there is not document open which corresponds to the
	// given file, or the document does not support interface for retrieving 
	// it's content in a text form

	wxPMFileLoader* pLoader = file.GetFileLoader();

	wxASSERT( pLoader ); // DBG::	

	bool ok = ::wxPMReadStreamToString( *pLoader->GetInputStream(), toStr );

	pLoader->Close();

	return ok;
}

bool wxPMProject::CanAcceptOtherFiles()
{
	return FALSE;
}

bool wxPMProject::OnCreate(const wxString& path, long flags)
{
	// overriden  in order to succeed without a view-class
	return TRUE;
}

bool wxPMProject::UseSerializer()
{
	return TRUE;
}

bool wxPMProject::SerializePMDocument( wxPMSerializer& ser )
{
	wxString docTypeName = this->GetDocumentTemplate()->GetDocumentName();

	ser.Exchange( "docTypeName", docTypeName );

	if ( ser.IsLoading() )
	{
		ser.SetPath( "Files" );
		long idx = 0; wxString name;

		bool ok = ser.GetFirstEntry( name, idx );

		while( ok )
		{
			wxString fname;
			ser.Exchange( name, fname );

			m_Files.Add( new wxPMFileInfo( fname ) );

			ok = ser.GetNextEntry( name, idx );
		}

		ser.SetPath( ".." );
	}
	else
	{
		if ( ser.Exists( "Files" ) ) 
			
			ser.DeleteGroup( "Files" );

		ser.SetPath( "Files" );

		for( size_t i = 0; i != m_Files.Count(); ++i )
		{
			wxString fname = m_Files[i]->GetPath();

			ser.Exchange( ser.IndexedKey( "file", i ), fname );
		}

		ser.SetPath( ".." );
	}

	return TRUE;
}

void wxPMProject::OnClosingChildDocument( wxPMDocument* pChild, bool wasSaved )
{
	if ( pChild->GetFileInfo() == NULL ) return;

	// automatically add new files upon closing the child-documents

	if ( !ContainsFile( *pChild->GetFileInfo() ) )
	
		AddFile( new wxPMFileInfo( *pChild->GetFileInfo() ) );
}

/*** command-event handlers ***/

void wxPMProject::OnCmdAddFile( wxCommandEvent& event )
{
	wxFileDialog dlg( wxPMBootSvc().GetMainWindow(), 
					  "Insert File into Project", "", "", "*.*", wxOPEN );

	if ( dlg.ShowModal() == wxID_OK )
	{
		wxPMFileInfo* pInfo = new wxPMFileInfo( dlg.GetPath() );

		AddFile( pInfo );
	}
}

void wxPMProject::OnCmdAddFiles( wxCommandEvent& event )
{
	InsertFiles( FALSE );
}

void wxPMProject::OnCmdFilesRecursively( wxCommandEvent& event )
{
	InsertFiles( TRUE );
}

void wxPMProject::OnCmdProjectSettings( wxCommandEvent& event )
{
	wxMessageBox( "OnCmdProjectSettings" );
}

/*** protecte methods ***/

void wxPMProject::DoInsertFiles( bool recursive, 
								 wxString topDir, 
								 const wxString& mask,
								 wxStringList& fileList )
{
	// NOTE:: this chunk of code is converted from v-0.0.1 of wxStudio

	if ( topDir[ topDir.Length()-1 ] != '/' ) 
		
		topDir.Append( "/" );

	wxString path = ::wxFindFirstFile( topDir + mask, wxFILE );

	while( path != "" )
	{
		fileList.Add( path );
		
		path = wxFindNextFile();
	}

	if ( recursive )
	{
		path = wxFindFirstFile( topDir + "*", wxDIR );

		wxStringList dirs;

		while( path != "" )
		{
			size_t len = path.Length();

			if ( path[len-1] != '.' )

				dirs.Add( path );
			
			path = wxFindNextFile();
		}

		for( size_t i = 0; i != dirs.GetCount(); ++i )

			DoInsertFiles( TRUE, dirs[i], mask, fileList );
	}
}

// TBD:: should be made static of wxPMProject class

static wxString _gPMProject_LRUMask = "*";

void wxPMProject::InsertFiles( bool recursive )
{
	wxTextEntryDialog* wcardDlg = 
		new wxTextEntryDialog( wxPMBootSvc().GetMainWindow(), 
							   "Enter mask of files to insert", 
							   "Insert Files", _gPMProject_LRUMask );

	if ( wcardDlg->ShowModal() == wxID_OK )
	{
		_gPMProject_LRUMask =  wcardDlg->GetValue();

		wxDirDialog dirDlg( wxPMBootSvc().GetMainWindow(), 
							"Choose directory", wxGetWorkingDirectory() );

		if ( dirDlg.ShowModal() == wxID_OK )
		{
			wxString path = dirDlg.GetPath() + "/";

			wxString file = wxFindFirstFile( path + _gPMProject_LRUMask, wxFILE );

			wxStringList fileList;

			DoInsertFiles( recursive, path, _gPMProject_LRUMask, fileList );

			PMFileInfoListT lst;

			for( size_t i = 0; i != fileList.GetCount(); ++i )

				lst.Add( new wxPMFileInfo( fileList[i] ) );

			this->AddMultipleFiles( lst );
		}
	}
}

/***** Implementation for class wxPMTempProject *****/

IMPLEMENT_DYNAMIC_CLASS( wxPMTempProject, wxPMProject )

wxPMTempProject::wxPMTempProject()
	: wxPMProject()
{
	SetTitle( "Other files" );
}

wxPMTempProject::~wxPMTempProject()
{}

bool wxPMTempProject::CanHaveFile()
{
	return FALSE;
}

bool wxPMTempProject::CanAcceptOtherFiles()
{
	return TRUE;
}

void wxPMTempProject::AddSubdocument( wxPMDocument* pSubdoc )
{
	wxPMProject::AddSubdocument( pSubdoc );

	if ( pSubdoc->CanHaveFile() &&
		 pSubdoc->GetFileInfo() &&
		 !ContainsFile( *pSubdoc->GetFileInfo() )
	   )
	
		AddFile( new wxPMFileInfo( *pSubdoc->GetFileInfo() ) );
}

/***** Implementation for class wxPMWorkplace *****/

// TBD:: should be made statics of wxPMWorkplace class

// mergable menus for wxPMWorkplace

static wxCommandInfo _gWorkplaceCommands[] = {

	wxCommandInfo( wxPMWorkplace::ID_COSE_WORKPLACE, "Close Workplace" ), 

	wxCommandInfo( 0, "" ) // terminator
};

static wxCommandInfo _gWorkplaceCommands1[] = {

	wxCommandInfo( wxPMWorkplace::ID_INSERT_PROJECT, "Insert Project..." ), 
	wxCommandInfo( wxPMWorkplace::ID_NEW_PROJECT, "Insert New Project..." ), 
	wxCommandInfo( wxPMWorkplace::ID_MAKE_PROJECT_ACTIVE, "Set Active Project..." ), 

	wxCommandInfo( -1, "SEPARATOR" ), 

	wxCommandInfo( wxPMWorkplace::ID_COSE_WORKPLACE, "Close workplace" ), 
	wxCommandInfo( wxPMWorkplace::ID_NEW_WORKPLACE, "New Workplace..." ), 

	wxCommandInfo( 0, "" ) // terminator
};

static wxCommandInfo _gWorkplaceCommands2[] = {

	wxCommandInfo( wxPMWorkplace::ID_TIPS, "&Tips!" ), 
	wxCommandInfo( 0, "" ) // terminator
};


static wxPMMergableMenuChain _gWorkplaceChains[] = {

	wxPMMergableMenuChain( "/&File/Open &Workplace...", _gWorkplaceCommands ),
	wxPMMergableMenuChain( "/&Workplace/", _gWorkplaceCommands1 ),
	wxPMMergableMenuChain( "/&Tips/", _gWorkplaceCommands2 ),

	wxPMMergableMenuChain( "", NULL ) // terminator
};

IMPLEMENT_DYNAMIC_CLASS( wxPMWorkplace, wxPMDocument )

BEGIN_EVENT_TABLE( wxPMWorkplace, wxDocument )

	EVT_MENU( wxPMWorkplace::ID_INSERT_PROJECT,      wxPMWorkplace::OnCmdInsertProject )
	EVT_MENU( wxPMWorkplace::ID_NEW_PROJECT,         wxPMWorkplace::OnCmdNewProject )
	EVT_MENU( wxPMWorkplace::ID_MAKE_PROJECT_ACTIVE, wxPMWorkplace::OnCmdMakeProjectActive )
	EVT_MENU( wxPMWorkplace::ID_COSE_WORKPLACE,      wxPMWorkplace::OnCmdCloseWorkplace )
	EVT_MENU( wxPMWorkplace::ID_NEW_WORKPLACE,       wxPMWorkplace::OnCmdNewWorkplace )
	EVT_MENU( wxPMWorkplace::ID_TIPS,				 wxPMWorkplace::OnCmdTips )

END_EVENT_TABLE()

wxPMWorkplace::wxPMWorkplace()

	: m_pActivePrj( NULL ),
	  m_pLayoutAlg( NULL )
{
	//wxMessageBox( "DBG:: wxPMWorkplace object created!" );
}

wxPMWorkplace::~wxPMWorkplace()
{}

bool wxPMWorkplace::OnCreate(const wxString& path, long flags)
{
	// overriden  in order to succeed without a view-class
	return TRUE;
}

wxPMMergableMenuChain* wxPMWorkplace::GetMergableMenuChain()
{
	return _gWorkplaceChains;
}

void wxPMWorkplace::SetLayoutAlgorithm( wxPMLayoutAlgorithm* pAlg )
{
	m_pLayoutAlg = pAlg;
}

wxPMLayoutAlgorithm* wxPMWorkplace::GetLayoutAlgorithm()
{
	return m_pLayoutAlg;
}

void wxPMWorkplace::SetActiveProject( wxPMProject* pPrj )
{
	if ( m_pActivePrj == pPrj )

		return; // should not be set twice

	wxPMProject* pPrevActive = m_pActivePrj;

	if ( pPrevActive )

		wxPMBootSvc().StopService( pPrevActive );

	m_pActivePrj = pPrj;

	for( size_t i = 0; i != m_Subdocuments.Count(); ++i )

		if ( m_Subdocuments[i] == pPrj )

			m_ActivePrjNo = i;

	wxPMBootSvc().StartService( m_pActivePrj );

	wxPM_NOTIFY_TWO_ARG( OnProjectActivated, *pPrj, pPrevActive )
}

wxPMProject* wxPMWorkplace::GetActiveProject()
{
	return m_pActivePrj;
}

bool wxPMWorkplace::IsActiveProject( wxPMProject* pPrj )
{
	return pPrj == m_pActivePrj;
}

void wxPMWorkplace::AddProject( wxPMProject* pPrj )
{
	AddSubdocument( pPrj );

	wxPM_NOTIFY_ONE_ARG( OnProjectAdded, *pPrj )

	if ( this->GetSubdocuments().Count() == 1 )

		SetActiveProject( pPrj );

	Modify( TRUE );
}

void wxPMWorkplace::RemoveProject( wxPMProject* pPrj )
{
	wxPM_NOTIFY_ONE_ARG( OnProjectRemoved, *pPrj )

	RemoveSubdocument( pPrj );
}

size_t wxPMWorkplace::GetProjectCount()
{
	return GetSubdocuments().Count();
}

wxPMProject& wxPMWorkplace::GetProject( size_t index )
{
	return *(wxPMProject*)GetSubdocuments()[index];
}

void wxPMWorkplace::UpdateUIForView( wxPMView* pView )
{
	// TBD::
}

void wxPMWorkplace::AddListener( wxPMWorkplaceListener* pListener )
{
	m_Listeners.Add( pListener );
}

void wxPMWorkplace::RemoveListener( wxPMWorkplaceListener* pListener )
{
	m_Listeners.Remove( pListener );
}

void wxPMWorkplace::OnClosingChildDocument( wxPMDocument* pChild, bool wasSaved )
{
	if ( pChild->CanHaveFile() == FALSE ||
		 pChild->GetFileInfo() == NULL ) return;

	m_Files.Add( new wxPMFileInfo( *pChild->GetFileInfo() ) );
}

void wxPMWorkplace::NotifyFileAdded( wxPMFileInfo& file, wxPMProject* pPrj )
{
	wxPM_NOTIFY_TWO_ARG( OnFileAdded, file, pPrj )
}

void wxPMWorkplace::NotifyFileRemoved( wxPMFileInfo& file, wxPMProject* pPrj )
{
	wxPM_NOTIFY_TWO_ARG( OnFileRemoved, file, pPrj )
}

bool wxPMWorkplace::UseSerializer()
{
	return TRUE;
}

bool wxPMWorkplace::SerializePMDocument( wxPMSerializer& ser )
{
	wxString docTypeName = this->GetDocumentTemplate()->GetDocumentName();

	ser.Exchange( "docTypeName", docTypeName );

	PMDocumentListT& subDocs = GetSubdocuments();

	if ( ser.IsLoading() )
	{
		long activeIdx = 0;

		ser.Exchange( "activeProjectIndex", activeIdx );

		long idx = 0; wxString name; long n = 0;

		ser.SetPath( "Projects" );

		bool ok = ser.GetFirstEntry( name, idx );

		while( ok )
		{
			wxString fname;
			ser.Exchange( name, fname );

			wxPMFileInfo finfo( fname );

			wxPMProject* pPrj = wxPMBootSvc().GetDocManager()->OpenProject( finfo );

			if ( n == activeIdx )

				this->SetActiveProject( pPrj );

			ok = ser.GetNextEntry( name, idx );
			++n;
		}

		ser.SetPath( ".." );
	}
	else
	{
		long n = m_ActivePrjNo; 

		ser.Exchange( "activeProjectIndex", n );

		if ( ser.Exists( "Projects" ) ) ser.DeleteGroup( "Projects" );

		ser.SetPath( "Projects" );

		for( size_t i = 0; i != m_Files.Count(); ++i )
		{
			wxString fname = m_Files[i]->GetPath();

			ser.Exchange( ser.IndexedKey( "file", i ), fname );
		}

		ser.SetPath( ".." );
	}

	return TRUE;
}

/*** command-event handlers ***/

void wxPMWorkplace::OnCmdInsertProject( wxCommandEvent& event )
{
	// FIXME:: what about extention of the project as we
	//		   do not know it's exact type at this moment...?

	wxFileDialog dlg( wxPMBootSvc().GetMainWindow(), 
					  "Insert existing project", "", "", "*.wsp", wxOPEN );

	if ( dlg.ShowModal() == wxID_OK )
	{
		wxPMDocManager& mgr = *wxPMBootSvc().GetDocManager();

		mgr.CreatePMDocument( wxPMFileInfo( dlg.GetPath() ), 0, 
							  mgr.FindTemplateForDocClass( CLASSINFO(wxPMProject) ) );
	}
}

void wxPMWorkplace::OnCmdNewProject( wxCommandEvent& event )
{
	wxPMDocManager& mgr = *wxPMBootSvc().GetDocManager();

	mgr.CreatePMDocument( wxPMFileInfo(), wxDOC_NEW, 
						  mgr.FindTemplateForDocClass( CLASSINFO(wxPMProject) ) );
}

void wxPMWorkplace::OnCmdMakeProjectActive( wxCommandEvent& event )
{
}

void wxPMWorkplace::OnCmdCloseWorkplace( wxCommandEvent& event )
{
	wxPMBootSvc().GetDocManager()->CloseWorkplace();
}

void wxPMWorkplace::OnCmdNewWorkplace( wxCommandEvent& event )
{
	wxMessageBox( "TBD:: wxPMWorkplace::OnCmdNewWorkplace()" );
}

void wxPMWorkplace::OnCmdTips( wxCommandEvent& event )
{
	wxMessageBox( "There are no scrollbars in menu or widget editors,\n"
				  "use right-click + dragging to navigate around the canvas.\n\n"

				  "Editing of window-resources is not supported yet,\n"
				  "(empty canvas is shown instead)\n\n"

				  "To change source-generation rules, edit\n"
				  "config_srctempl.txt\n\n"

				  "Restart demo to apply changes made in config_* files\n\n"

				  "Alt+Backspace - to undo operation,\n"
				  "Ctrl+A - to redo operation,\n\n"

				  "If you have lost or closed some pane,\n"
				  "right-click on the very edge of main window\n"
				  "to bring it back (context menu will appear)"
				  );
}