#ifndef __NBOOKGLYPH_G__
#define __NBOOKGLYHP_G__

#include "widgeteditor.h"
#include "wx/dynarray.h"

class NotebookNode : public WidgetNode
{
public:
	NotebookNode();
	~NotebookNode();

	// overriden method of wxDMNode
	virtual wxDMNode* Clone( bool uniqueCopy, bool cloneChildren = TRUE );

	// overriden methods of WidgetNode
	virtual void DoLayoutChildren( wxDC& dc );

	virtual void OnChildInserted( wxDMNode* pNode );
	virtual void OnChildRemoved( wxDMNode* pNode );
	virtual void OnChildChanged( wxDMNode* pNode );

	DECLARE_DYNAMIC_CLASS( NotebookNode )

protected:
	virtual void DoUpdateGlyphForNode( wxDMNode* pChild );
};

class NotebookPageInfo : public wxObject
{
public:
	wxString mLabel;
	wxBitmap mImage;
	XPoint   mLabelPos;
	XPoint   mImagePos;
	XRect	 mTabBounds;
};

WX_DEFINE_ARRAY( NotebookPageInfo*, NotebookPageInfoListT );

class NotebookGlyph : public WidgetGlyph
{
public:
	NotebookGlyph();
	~NotebookGlyph();

	// overriden methods of WidgetGlyph
	virtual void Draw( wxDC& canvas);
	virtual void SetBounds( const XRect& bounds );
	virtual void SetBoundsSilent( const XRect& bounds );

	// overriden method of XObject
	virtual bool OnMouseDown ( const XPoint& pos );

	DECLARE_DYNAMIC_CLASS( NotebookGlyph )

protected:
	void DrawTab( NotebookPageInfo& tab, wxDC& dc, bool isActive );
	void RecalcPageInfos( wxDC& dc );

	friend class NotebookNode;

protected:
	NotebookPageInfoListT mPageInfos;
	XRect				  mActivePageBounds;
	size_t				  mActivePageIdx;
};

#endif // __NBOOKGLYHP_G__