#ifndef __STRLIST_G__
#define __STRLIST_G__

#include "wx/dynarray.h"

WX_DEFINE_ARRAY( wxString*, StringPtrArrayT );

class wxDynStrList : public wxObject
{
public:
	void Add( const wxString& str );
	void Remove( const wxString& str );
	void Remove( size_t index );
	wxString& Item( size_t index ) const;
	wxString& operator[]( size_t index ) const;
	void Insert( const wxString& str, size_t uiIndex);
	wxString& Last() const;
	bool IsEmpty() const;
	int GetCount() const;
	int Count() const ;
	void Clear();

protected:
	StringPtrArrayT mStrArray;
};

typedef wxDynStrList StrListT;

#endif // __STRLIST_G__