/////////////////////////////////////////////////////////////////////////////
// Name:        No names yet.
// Purpose:     Contrib. demo
// Author:      Aleksandras Gluchovas
// Modified by:
// Created:     2000/02/08
// RCS-ID:      
// Copyright:   (c) Aleksandras Gluchovas
// Licence:   	GPL (version 2.0 or later)
/////////////////////////////////////////////////////////////////////////////

#ifdef __GNUG__
    #pragma implementation "minimal.cpp"
    #pragma interface "minimal.cpp"
#endif

#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#if defined(__WXGTK__) || defined(__WXMOTIF__)
    #include "mondrian.xpm"
#endif

#define USE_PM_GUI 1
#define USE_RESOURCE_EDITING 1

#include "wkp_main.h"
#include "pm_sample.h"

#include "wx/pmf/pm_flmgr.h"
#include "wx/pmf/pm_prjtempl.h"
#include "wx/pmf/pm.h"
#include "wx/pmf/lseditor.h"  // glt

#include "wx/fileconf.h"

#include "hellosvc.h"

#include "wx/pmf/srceditordoc.h"

#if USE_RESOURCE_EDITING

#include "res_doc.h"
#include "widgeteditor.h"
#include "menuedit.h"
#include "ui_lookeditor.h"
#include "bmpeditor.h"

#endif

#include "wx/log.h"
#include <stdio.h> // sprintf()

class MyApp : public wxApp
{
public:
    virtual bool OnInit();
};

wxPMDocManager* _gDocMgr = NULL;
wxDocTemplate* _gMyTestPrjTempl = NULL;

#if USE_PM_GUI
#include "wx/pmf/pm_gui.h"
#endif

bool MyApp::OnInit()
{
	_gDocMgr = new wxPMDocManager();

	new wxDocTemplate( _gDocMgr, "PM-SimpleWorkplace-document", "*.wsw", 
					   "", // default dir
					   "wsw", "text/x-my-wxStudio-workplace",
					   "view-type-name", 
					   CLASSINFO( wxPMSimpleWorkplace ), 
					   NULL // no view 
					 );

#if USE_PM_GUI
	new wxPMProjectCreatorTemplate( _gDocMgr, "Project...", "*.wsp", 
					   "", // default dir
					   "wsp",
					   "", // type is EMPTY string to allow autodetection of concreate type
						   // upon loading of the document
					   "", 
					   CLASSINFO( wxPMProject ), NULL
					 );
#endif

	new wxDocTemplate( _gDocMgr, "Other-files", "*.*", 
					   "", // default dir
					   "","","",
					   CLASSINFO( wxPMTempProject ),
					   NULL, // no view
					   wxTEMPLATE_INVISIBLE // !!
					 );

	new wxDocTemplate( _gDocMgr, "My Text Document", "*.txt", 
					   "", // default dir
					   "txt", "text/plain",
					   "my-default-text-viewer-type", 
					   CLASSINFO( wxPlainTextDocument ), 
					   CLASSINFO( wxPlainTextView )
					 );

#if USE_RESOURCE_EDITING

	new wxDocTemplate( _gDocMgr, "wxWin-Resource-Document", "*.xml", 
					   "", // default dir
					   "xml", "text/x-wx-resource",
					   "my-default-resource-viewer-type", 
					   CLASSINFO( ResDocument ), 
					   NULL
					 );

	new wxDocTemplate( _gDocMgr, "wxWin-Widget-Resource-Document", "*.zzz", 
					   "", // default dir
					   "zzz", "text/x-widget-resource",
					   "my-default-widget-resource-viewer", 
					   CLASSINFO( WidgetDocument ), 
					   CLASSINFO( WidgetView ), 
					   wxTEMPLATE_INVISIBLE  // used only through ResDocument
					 );


	wxDocTemplate* pBmpTempl = 
	new wxDocTemplate( _gDocMgr, "wxWin-Bitmap-Resource-Document", "*.zzz", 
					   "", // default dir
					   "zzz", "text/x-bitmap-resource",
					   "my-default-bitmap-resource-viewer", 
					   CLASSINFO( BitmapEditorDoc ), 
					   CLASSINFO( BitmapEditorView ) 
					   //wxTEMPLATE_INVISIBLE  // used only through ResDocument
					 );

	new wxDocTemplate( _gDocMgr, "wxWin-Menubar-Resource-Document", "*.zzz", 
					   "", // default dir
					   "zzz", "text/x-menubar-resource",
					   "my-default-menubar-resource-viewer", 
					   CLASSINFO( MenuEditorDoc ), 
					   CLASSINFO( MenuEditorView ), 
					   wxTEMPLATE_INVISIBLE 
					 );

	new wxDocTemplate( _gDocMgr, "Widget-Look Resource", "*.wlk", 
					   "", // default dir
					   "wlk", "text/x-widget-look",
					   "my-default-widget-look-viewer-type", 
					   CLASSINFO( wxUILookDocument ), 
					   CLASSINFO( wxUILookView )
					 );

#endif // USE_RESOURCE_EDITING

	new wxDocTemplate( _gDocMgr, "My Html Document", "*.html;*.htm;*.sgml", 
					   "", // default dir
					   "html", "text/html",
					   "html-default-text-viewer-type", 
					   CLASSINFO( wxPlainTextDocument ), 
					   CLASSINFO( wxHtmlView )
					 );

	new wxDocTemplate( _gDocMgr, "My Htm Document", "*.html;*.htm;*.sgml", 
					   "", // default dir
					   "htm", "text/html",
					   "htm-default-text-viewer-type", 
					   CLASSINFO( wxPlainTextDocument ), 
					   CLASSINFO( wxHtmlView )
					 );

	new wxDocTemplate( _gDocMgr, "C++ Include File", "*.h;*.hpp", 
					   "", // default dir
					   "h", "text/x-h",
					   "h-source-code-document-type", 
					   CLASSINFO( wxSourceCodeDocument ), 
					   CLASSINFO( wxSourceCodeView )
					 );

	new wxDocTemplate( _gDocMgr, "C++ Source File", "*.cpp;*.C", 
					   "", // default dir
					   "cpp", "text/x-cpp",
					   "cpp-source-code-document-type", 
					   CLASSINFO( wxSourceCodeDocument ), 
					   CLASSINFO( wxSourceCodeView )
					 );

	new wxDocTemplate( _gDocMgr, "C Source File", "*.c", 
					   "", // default dir
					   "c", "text/x-c",
					   "c-source-code-document-type", 
					   CLASSINFO( wxSourceCodeDocument ), 
					   CLASSINFO( wxSourceCodeView )
				     );

	new wxDocTemplate( _gDocMgr, "Java Source File", "*.java", 
					   "", // default dir
					   "java", "text/java",
					   "java-source-code-document-type", 
					   CLASSINFO( wxSourceCodeDocument ), 
					   CLASSINFO( wxSourceCodeView )
				     );

	new wxDocTemplate( _gDocMgr, "Python Source File", "*.py", 
					   "", // default dir
					   "py", "text/x-python",
					   "python-source-code-document-type", 
					   CLASSINFO( wxSourceCodeDocument ), 
					   CLASSINFO( wxSourceCodeView )
					 );

	// templates for actual projects

	_gMyTestPrjTempl =
		new wxDocTemplate( _gDocMgr, "My C++ Project", "*.wsp", 
						   "", // default dir
						   "wsp", "text/x-my-wxStudio-project",
						   "", 
						   CLASSINFO( wxPMProject ), 
						   NULL//, // no view
						   //wxTEMPLATE_INVISIBLE // !!
						 );

	wxPMFileInfo::RegisterDefaultTypeFallbacks(); // "text/plain", "text/html", etc
	wxPMFileInfo::RegisterTypeFallback( "text/x-my-wxStudio-workplace", "wsw" );
	wxPMFileInfo::RegisterTypeFallback( "text/x-my-wxStudio-project",   "wsp" );

    MyFrame *frame = new MyFrame( _gDocMgr, "wxWorkshop v-0.3-Demo",
                                 wxPoint(50, 50), wxSize(650, 500));

    frame->Show(TRUE);
    SetTopWindow(frame);

#if 0
	bool ok = _gDocMgr->OpenDocument( wxPMFileInfo( "first_cool.wsw" ), NULL );
	wxPMDocument* pPrjDoc = wxPMBootSvc().GetWorkplace()->GetActiveProject();

	//_gDocMgr->OpenDocument( wxPMFileInfo( "D:\\projects\\wxs\\ws\\unnamed2.xml" ), pPrjDoc );
	wxCommandEvent evt( wxEVT_COMMAND_MENU_SELECTED  );
	evt.SetId( wxID_NEW );
	_gDocMgr->ProcessEvent( evt );

	//wxPMDocument* pDoc = _gDocMgr->OpenDocument( wxPMFileInfo( "D:\\projects\\aworkplace\\gamma.xml" ), pPrjDoc );

	//wxPMDocument* pDoc = _gDocMgr->OpenDocument( wxPMFileInfo( "D:\\projects\\aworkplace\\config_stdwlooks.wlk" ), pPrjDoc );

	//pDoc->Modify( TRUE );
	//wxPMBootSvc().GetDocManager()->SaveDocument( pDoc );
	//wxPMDocument* pDoc = _gDocMgr->OpenDocument( wxPMFileInfo( "D:\\projects\\aworkplace\\a.cpp" ), pPrjDoc );
	//_gDocMgr->ActivateDocument( pDoc );
#endif

    return TRUE;
}

IMPLEMENT_APP(MyApp)

// global helper functions

static wxString IntToStr( int i ) 
{ 
	char buf[32]; 
	sprintf(buf,"%d",i); return buf; 
}

extern void TestFileConfig();

/***** Implementation for class MyFrame *****/

BEGIN_EVENT_TABLE(MyFrame, wxDocMDIParentFrame)
    EVT_MENU(Minimal_Quit,  MyFrame::OnQuit)
    EVT_MENU(Minimal_About, MyFrame::OnAbout)
	EVT_CHAR_HOOK( MyFrame::OnCharHook )

	EVT_CLOSE( MyFrame::OnClose )
END_EVENT_TABLE()

MyFrame::~MyFrame()
{
	if ( mpLogFrm )
	{
		delete wxLog::SetActiveTarget(NULL);
		mpLogFrm->Destroy();
	}

    wxTextEditorView::KillTimer();

#if USE_PM_GUI
	wxPMProjectCreatorDialog::RemoveAllTemplates();
#endif

	if ( _gDocMgr ) 
	{
		delete _gDocMgr;
		_gDocMgr = NULL;
	}
}

MyFrame::MyFrame( wxDocManager* manager, const wxString& title, 
				  const wxPoint& pos, const wxSize& size)
       : wxDocMDIParentFrame( manager, (wxFrame *)NULL, -1, title, pos, size),
		 mpLogFrm( NULL ),
		 mpDocMgr( manager )
{
	/***** debug ******/
	#if 0
		mpLogFrm = new wxFrame( NULL,-1,"Log", wxDefaultPosition, wxSize(500,200) );
		wxTextCtrl *textCtrl = new wxTextCtrl(mpLogFrm, -1, "",wxDefaultPosition,wxDefaultSize, wxTE_MULTILINE | wxSUNKEN_BORDER);
		wxLogTextCtrl *logWindow = new wxLogTextCtrl(textCtrl);
		delete wxLog::SetActiveTarget(logWindow);
		mpLogFrm->Show(TRUE);
	#endif
	/*******************************/

    // set the frame icon
    SetIcon(wxICON(mondrian));

	/********* PMF-initialization from user-code **********/
	wxPMBitmapManager* pBmpMgr = new wxPMBitmapManager();
	pBmpMgr->SetRelativePath( ::wxGetCwd() + "/images" );
	pBmpMgr->SetDefaultExtension( "bmp" );

	wxPMBootstrapService* pBootSvc = new wxPMBootstrapService( this, _gDocMgr );

	RegisterCreationTemplates();

	#if 0
		TestProjectCreator();
		return;
	#endif

	#if 0
		TestKeyBinder();
		return;
	#endif

	#if 0
		TestFileConfig();
	#endif


	pBootSvc->Start();

	#if 0
		wxPMSashLayoutAlgorithm* pAlg = new wxPMSashLayoutAlgorithm();
	#else
		wxPMFrameLayoutAlgorithm* pAlg = new wxPMFrameLayoutAlgorithm();
	#endif

	pBootSvc->AddService( pAlg );
	pBootSvc->StartService( pAlg );

	HelloService* hello = new HelloService();
	pBootSvc->AddService( hello );
	pBootSvc->StartService( hello );

#if wxUSE_STATUSBAR
    // create a status bar just for fun (by default with 1 pane only)
    CreateStatusBar(2);
    SetStatusText("Welcome to wxWindows!");
#endif // wxUSE_STATUSBAR

}

// event handlers							

void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{
	if ( wxPMBootSvc().CleanUp() )

	    // TRUE is to force the frame to close
		Close(TRUE);
}

void MyFrame::OnClose(wxCloseEvent& event)
{
	if ( wxPMBootSvc().CleanUp() )

		event.Skip(); // allow closure if PMF has "agreed"
}

void MyFrame::OnCharHook( wxKeyEvent& event )
{
	if ( event.AltDown() || event.ControlDown() )
	
		wxPMBootSvc().TranslateKeyEvent( event );
	else
		event.Skip();
}

void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{
    wxString msg;
    msg.Printf( "This is the about dialog of wxUIEditor.\n"
                "Welcome to %s"
#ifdef wxBETA_NUMBER
               " (beta %d)!"
#endif // wxBETA_NUMBER
               , wxVERSION_STRING
#ifdef wxBETA_NUMBER
               , wxBETA_NUMBER
#endif // wxBETA_NUMBER
              );

    wxMessageBox(msg, "About wxWorkplace-Test", wxOK | wxICON_INFORMATION, this);
}


void MyFrame::RegisterCreationTemplates()
{
#if USE_PM_GUI
	PMProjectTypeTemplateListT lst;
	wxDocTemplate* t = _gMyTestPrjTempl;

	// empty

	lst.Add( new wxPMProjectTypeTemplate( "/", 
										  "Empty Project", "", "misc/32x32_empty", t) );

	// C++

	lst.Add( new wxPMProjectTypeTemplate( "/wxWindows C++ Applications/", 
										  "Classical wxApp", "", "misc/32x32_wx", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxWindows C++ Applications/", 
										  "MDI-App Wizzard", "", "misc/32x32_wizzard", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxWindows C++ Applications/", 
										  "Dynamic Lybarary", "", "misc/32x32_dll", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxWindows C++ Applications/", 
										  "Dialog-driven App", "", "misc/32x32_applet", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxWindows C++ Applications/", 
										  "Netscape Plug-in", "", "misc/32x32_appletcode", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxWindows C++ Applications/", 
										  "wxODBC Database-App", "", "misc/32x32_db", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxWindows C++ Applications/", 
										  "Console wxApp", "", "misc/32x32_selfextract", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxWindows C++ Applications/", 
										  "wxSockServer\nWizzard", "", "misc/32x32_service", t) );

	// Python

	lst.Add( new wxPMProjectTypeTemplate( "/wxPython Applications/", 
										  "wxPython Classic", "", "misc/32x32_python", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxPython Applications/", 
										  "Python Distributed", "", "misc/32x32_vdiff", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/wxPython Applications/", 
										  "wxPython XML-App", "", "misc/32x32_notemaker", t) );

	// distr

	lst.Add( new wxPMProjectTypeTemplate( "/Distribution Projects/Packaging/", 
										  "ZIP\nArichive", "", "misc/32x32_zip", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/Distribution Projects/Packaging/", 
										  "RPM\nPackage", "", "misc/32x32_zipfile", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/Distribution Projects/Packaging/", 
										  "Debian\nPackage", "", "misc/32x32_cab", t) );

	// installers

	lst.Add( new wxPMProjectTypeTemplate( "/Distribution Projects/Installers/", 
										  "WIN32 Installer (x86)", "", "misc/32x32_installer.bmp", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/Distribution Projects/Installers/", 
										  "Python App-Installer", "", "misc/32x32_python", t) );
	lst.Add( new wxPMProjectTypeTemplate( "/Distribution Projects/Installers/", 
										  "GNOME\nShield..;-)", "", "misc/32x32_util", t) );

	wxPMProjectCreatorDialog::SetDefaultCategory( "/wxWindows C++ Applications/" );

	wxPMProjectCreatorDialog::AddTemplates( lst );

#endif
}

void MyFrame::TestProjectCreator()
{
#if USE_PM_GUI

	//--------- code to test wxPMProjectCreatorDialog -----------
	wxPMProjectCreatorDialog dlg( NULL, "Project1", 
								  ::wxGetWorkingDirectory() );
	dlg.ShowModal();

	Destroy();

#endif
}

void MyFrame::TestKeyBinder()
{
	wxKeyBinder* pBinder = new wxKeyBinder();

	wxCommandGroup* g1 = new wxCommandGroup( "File" );
	wxCommandInfo* pInfo1 = new wxCommandInfo( 7, "Open", "Open a file for editing" );
	wxCommandInfo* pInfo2 = new wxCommandInfo( 8, "Save", "Save modifications to file" );

	pInfo2->AddKey( WXK_SPACE, wxCONTROL_DOWN | wxSHIFT_DOWN );
	
	g1->AddSubcommand( pInfo1 );
	g1->AddSubcommand( pInfo2 );

	pBinder->AddGroup( g1 );

	wxKeyConfigDialog dlg( this, pBinder );
	dlg.ShowModal();

	delete pBinder;
}

void TestFileConfig()
{
	//wxTextFile fl("c:\\0\\raibas.txt");
	//fl.Open();
	//wxASSERT( fl.IsOpened() );


	//wxFileConfig fc( "MyAppName","", "", "c:\\0\\raibas.txt",
	//				 wxCONFIG_USE_GLOBAL_FILE );
	wxFileConfig fc( "MyAppName","", "d:\\0\\raibas.txt","",
					 wxCONFIG_USE_LOCAL_FILE );

	//wxFileConfig fc( "apas" );

	fc.SetPath( "/" );
#if 0
	fc.Write( "root_key1", "root_val1_modified" );
#else
	fc.SetPath( "/firstdir" );
	fc.Write( "fdir_myvar0", "fdir_myvalue0" );
	fc.Write( "fdir_myvar1", "fdir_myvalue1" );
	fc.SetPath( "/firstdir/subdir1" );
	fc.Write( "fdir_sub_myvar1", "fdir_sub_myvalue10" );
	fc.SetPath( "subdir2" );
	fc.Write( "stj_ub", "uhiuh" );
	fc.SetPath( "../.." );
	fc.Write( "fdir_myvar2", "fdir_myvalue22-10" );
#endif
	fc.Flush();

};

#ifdef __HACK_MY_MSDEV40__

char wxDummyChar = 0;

#endif